package debugger;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Scrollbar;

import javax.swing.*;
import javax.swing.JScrollPane.*;

public class debugWindow extends JFrame{
	//ݕ\̂
	private debugObject current_obj;
	//fobOIuWFNg̊Ǘ
	private debugObjectManager debugObjs = new debugObjectManager();

	//ʂ̏㉺؂蕪
	private JSplitPane splitcomp = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
	//s`a
	private JTabbedPane tabcomp = new JTabbedPane();

	//
	private JPanel icons_pane = new JPanel();
	//s{^
	private JToggleButton play_button = new JToggleButton("s");
	
	//sĂ悢ǂ̃tO
	private boolean running_flag;

	/**
	 * VOĝ߁AvCx[g RXgN^
	 */
	private debugWindow(){
	}
	static private debugWindow _this;
	
	/** VOgB
	 * 
	 * @return fobOEChEIuWFNgԂ
	 */
	public static debugWindow getInstance(){
		if(_this ==null){
			_this = new debugWindow();
		}
		return _this;
	}
	
	/** 
	 */
	public void init(){

		this.setName("debugWindow");
		//this.setSize(200,480);
		this.setBounds(640,20,290,480);

		this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

		setLayout(new BorderLayout());


		//s{^̏̕
		icons_pane.setLayout(new BorderLayout() );
		icons_pane.add(play_button);
		
		
		//㉺킯̐ݒ
		this.splitcomp.setRightComponent(tabcomp);
		this.splitcomp.setLeftComponent( icons_pane );
		this.splitcomp.setDividerSize(0);
		this.splitcomp.setDividerLocation(30);
		this.splitcomp.setEnabled(false);
		this.add(splitcomp);
		this.setVisible(true);	
	}
	
	
	/** fobOIuWFNgZbg
	 * @param name IuWFNg
	 * @param obj fobOIuWFNg
	 */
	public void setObject(String name,Object obj){
		JPanel comp = null;
		debugObject tmp = null;
		if( debugObjs.isMember(obj)==null ){ // ΁Aǉ
			comp = new JPanel();
			comp.setLayout(new BorderLayout());
			tmp = new debugObject(name,obj , comp);
			this.tabcomp.add(comp,name);
			debugObjs.add( tmp,obj);
			this.current_obj = tmp;
		}
	}

	/** fobOΏۂƂȂIuWFNgZbg
		* @param obj IuWFNg̒l
		*/
	public void setCurrent(Object obj){
		this.current_obj = debugObjs.isMember(obj);
	}

	/** IuWFNg
	 * @param obj fobOsĂIuWFNg
	 */
	public void removeObject(Object obj){
		debugObjs.remove(this.tabcomp , obj );
	}
	
	
	/** ϐ̒ǉ
	 * @param name ϐ̖O
	 * @param type ϐ̌^
	 * @param val ϐ̒l
	 * @param arr z̎
	 */
	public void addVar(String name,int type,Object val,int arr){
		if(current_obj==null){
			return;
		}
		this.current_obj.addVar( new debugVar(name,type,val,arr) );	
	}
	 
	/** Jgϐgbvɂ
	 * ϐ̃Abvf[g/擾͒ǉɂ肢܂B
	 */
	public void iterateVarStart(){
		if(current_obj==null){
			return;
		}
		this.current_obj.iterateVarStart();
	}

	/** ϐ̃Abvf[gs̕ϐֈړ
	 * 
	 * @param obj ϐɃZbgl
	 */
	public void updateVar(Object obj){
		if(current_obj==null){
			return;
		}
		this.current_obj.updateVar(obj);
	}
	
	/** ϐԂA̕ϐֈړ
	 * @return ϐnai
	 */
	public debugVar getVar(){
		if(current_obj==null){
			return null;
		}
		return this.current_obj.getVar();
	}
	
	/** ϐINT^Ƃ݂ȂAg̒loA̕ϐֈړ
	 * @return ϐint^̒l
	 */
	public int getVarAsInt(){
		if(current_obj==null){
			return 0;
		}
		return this.current_obj.getVarAsInt();		
	}
	
	/** ϐDOUBLE^Ƃ݂ȂAg̒loA̕ϐֈړ
	 * @return ϐdouble^̒l
	 */
	public double getVarAsDouble(){
		if(current_obj==null){
			return 0;
		}
		return this.current_obj.getVarAsDouble();				
	}
	

	/** ϐfloat^Ƃ݂ȂAg̒loA̕ϐֈړ
	 * @return ϐfloat^̒l
	 */
	public float getVarAsFloat(){
		if(current_obj==null){
			return 0;
		}
		return this.current_obj.getVarAsFloat();				
	}
	
	/** ϐString^Ƃ݂ȂAg̒loA̕ϐֈړ
	 * @return ϐString^̒l
	 */
	public String getVarAsString(){
		if(current_obj==null){
			return null;
		}
		return this.current_obj.getVarAsString();		
	}
	
	/** ϐchar^Ƃ݂ȂAg̒loA̕ϐֈړ
	 * @return ϐchar^̒l
	 */
	public char getVarAsChar(){
		if(current_obj==null){
			return 0;
		}
		return this.current_obj.getVarAsChar();				
	}
	
	/** ϐoCg^Ƃ݂ȂAg̒loA̕ϐֈړ
	 * @return ϐbyte^̒l
	 */
	public byte getVarAsByte(){
		if(current_obj==null){
			return 0;
		}
		return this.current_obj.getVarAsByte();		
	}
	
	/** ϐObject^Ƃ݂ȂAg̒loA̕ϐֈړ
	 * @return ϐObject^̒l
	 */
	public Object getVarAsObject(){
		if(current_obj==null){
			return null;
		}
		return this.current_obj.getVarAsObject();
	}

	/** ϐboolean^Ƃ݂ȂAg̒loA̕ϐֈړ
	 * @return ϐboolean^̒l
	 */
	public boolean getVarAsBoolean(){
		if(current_obj==null){
			return false;
		}
		return this.current_obj.getVarAsBoolean();		
	}
  

	/** ϐꗗ`悵܂
	 */
	public void draw(){
		boolean now_state = !this.play_button.isSelected();

		if( now_state != this.running_flag ){
			if(now_state){
				this.play_button.setText("s");
			}else{
				this.play_button.setText("~");
			}
			this.setRunningFlag(now_state);
		}
		//̃IuWFNgȂ`悵Ȃ
		if(current_obj==null){
			return;
		}
		try{
			this.debugObjs.getSelected(tabcomp).draw(this.running_flag);
		}catch(Exception e){
			e.printStackTrace();
		}
	}

	/** stÕZbg
	 * @param flag tÕZbg
	 */
	public void setRunningFlag(boolean flag){

		this.running_flag = flag;
		if(current_obj==null){
			return;
		}
		this.current_obj.setRunningFlag(flag);
	}
	
	/** sǂԂ 
	 * @return
	 */
	public boolean getRunningFlag(){
		return this.running_flag;
	}
}
