package gameCanvasUtil;


import java.awt.*;   // OtBbNXNX̓ǂݍ
import javax.swing.JFrame;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.*;
import java.lang.*;
import java.util.*;
import javax.swing.JOptionPane;
import javax.imageio.ImageIO;
import gameCanvasUtil.vector.*;
import gameCanvasUtil.classLoad.*;

/** ܂܂ȋ@\܂Ƃ߂NX
  *
  * {Iɂ͑ɂ炢񂷂ł
  */
public class gameCanvas{
	/** ʂ̕ */
	public static final int WIDTH=640;
	/** ʂ̍ */
	public static final int HEIGHT=480;
	/** FPS̐ݒ */
	public static final int CONFIG_FPS = 30;
	/** saveDatãTCY */
	private static final int SAVE_DATA_SIZE = 1024;
	
	
	/** {^ */
	public static final int KEY_UP=inputManager.BUTTON_UP;
	/** {^ */
	public static final int KEY_DOWN=inputManager.BUTTON_DOWN;
	/** {^ */
	public static final int KEY_LEFT=inputManager.BUTTON_LEFT;
	/** E{^ */
	public static final int KEY_RIGHT=inputManager.BUTTON_RIGHT;

	/** ZL[ */
	public static final int KEY_Z=inputManager.BUTTON_A;
	/** XL[ */
	public static final int KEY_X=inputManager.BUTTON_B;
	/** CL[ */
	public static final int KEY_C=inputManager.BUTTON_C;
	/** VL[ */
	public static final int KEY_V=inputManager.BUTTON_D;

	/** ENTER */
	public static final int KEY_ENTER=inputManager.BUTTON_PAUSE;

	/** SPACE */
	public static final int KEY_SPACE=inputManager.BUTTON_SELECT;
	
	
	//F֌W̒萔

	/** F */
	public static final int COLOR_WHITE =  0xFFFFFF;
	/** F */
	public static final int COLOR_BLACK =  0x000000;
	/** DF */
	public static final int COLOR_GRAY =   0x808080;
	/** ԐF */
	public static final int COLOR_RED =    0xFF0000;
	/** F */
	public static final int COLOR_BLUE =   0x0000FF;
	/** ΐF */
	public static final int COLOR_GREEN =  0x00FF00;
	/** F */
	public static final int COLOR_YELLOW = 0xFFFF00;
	/** F */
	public static final int COLOR_PURPLE = 0xFF00FF;
	/** VAF */
	public static final int COLOR_CYAN=    0x00FFFF;
	/** ݂ */
	public static final int COLOR_AQUA=    0x7F7FFF;

	//摜̊ǗƂIuWFNg
	private imageManager images;
	//SE̊ǗIuWFNg
	private soundManagerInterface sound_effect;
	//BGM̊ǗIuWFNg
	private soundManagerInterface bgm;
	//L[̓͂ǗIuWFNg
	private inputManager input;
	//sQ[C^[tF[XpIuWFNg
	private gameInterface game;

	//_p
	private Random rand = new Random();
	
	//tHgTCY
	private int FontSize=10;
	
	//OBGM
	private int bk_snd;

	//`
	private Graphics g;
	private Image offImage;

	//JFrameւ̎Q
	private JFrame frame;
	
	//VOgpɍ쐬
	static private gameCanvas _gc;
	
	//ftHgŋNQ[C^[tF[X
	private gameInterface default_game;


	/** VOg
	 * gameCanvasIuWFNgĂAԂBȂȂ琶ĕԂB
	 * @return gameCanvasIuWFNgԂ
	 */
	static public gameCanvas getInstance(){
		if(_gc==null)
			_gc = new gameCanvas();
		return _gc;
	}


	/** VOĝ߁AvCx[gRXgN^
	 */
	private gameCanvas(){
	}


	/** gameCanvas̏s
	 */
	public void init(JFrame _f){
		this.frame = _f;
		this.bk_snd = -1;
		
		this.setImageManager(new imageManager("res/img",imageManager.NUMBER_AUTO_CULC));
		this.setSeManager( new soundManager("res/snd",soundManager.NUMBER_AUTO_CULC));
		this.setBgmManager( new midiManager("res/bgm",midiManager.NUMBER_AUTO_CULC));
		this.changeBgmVolume(60);
		this.changeSeVolume(100);
		this.input = inputManager.getInstance();	
		this.readRecord();
	}



	/** gameCanvas̏Ȉł
	 */
	public void finalize(){
		if(this.game!=null){
			this.game.finalGame();
		}
		//Z[u
		if(save_flag){
			this.writeRecord();
			save_flag = false;
		}
	}

	/** GraphicsNXւ̎QƂZbg
	 * @param gra
	 */
	public void setGraphics(Graphics gra,Image img){
		this.g = gra;
		this.offImage = img;
		setFont("",0,25);
	}


	/** ݂̉ʂA摜Ƃĕۑ܂
	 * @param file gqt@C܂
	 * @return ۑɐԂ܂
	 */
	public boolean writeScreenImage(String file){
		BufferedImage cur_off = new BufferedImage(gameCanvas.WIDTH,gameCanvas.HEIGHT , BufferedImage.TYPE_INT_RGB);
		Graphics gr = cur_off.getGraphics();
		gr.drawImage( offImage , 0 , 0 , null );
		try{
			return ImageIO.write( cur_off , "PNG" , new File( file+".png") );
		}catch(Exception e){
			e.printStackTrace();
			return false;
		}
	}

	/** Window̕w肵܂
	 * @param title Window̃^Cg̕w
	 */
	public void setWindowTitle(String title){
		frame.setTitle(title);
	}


	/** `悷
	 * @param str `悷镶
	 * @param x   ̂wW
	 * @param y   ̂xW
	 */
	public void drawString(String str,int x,int y){
		g.drawString(str,x,y+g.getFont().getSize());
	}


	/** 𒆐Sʒuw肵ĕ`悷
	 * @param str `悷镶
	 * @param x   ŜwW
	 * @param y   ̂xW
	 */
	public void drawCenterString(String str,int x,int y){
		this.drawString(str, x - getStringWidth(str)/2,y);
	}


	/** E񂹂ɂĕ`悷
	 * @param str `悷镶
	 * @param x   ÊwW
	 * @param y   ̂xW
	 */
	public void drawRightString(String str,int x,int y){
		this.drawString(str, x - getStringWidth(str),y);
	}

	///tHgIuWFNg
	private Font myFont;

	/** drawStringȂǂŎgptHgύX܂B
	 * @param font_name tHg̎w
	 * @param font_style tHg̃X^C̎w
	 * @param font_size tHg̃TCY̎w
	 */
	public void setFont( String font_name, int font_style, int font_size){
		myFont = new Font(font_name,font_style,font_size);
		g.setFont(myFont);
		FontSize = font_size;
	}

	/** tHgTCY̕ύX
	 * @param font_size tHg̃TCYw肵܂
	 */
	public void setFontSize(int font_size){
		this.setFont("",0,font_size);
	}


	/**@̂ǂƕ𒲂ׂ܂
	 * 
	 * strdrawStringŕ`悵Ƃ̕Ԃ܂B
	 * @param str ׂ镶
	 * @return str`悵Ƃ̕
	 */
	public int getStringWidth(String str){
		FontMetrics obj = g.getFontMetrics();
		return obj.stringWidth(str);
	}


	/** drawStringAdrawRectȂǂŎgpF̃Zbg
	 * @param color RGBŎw
	 */	
	public void  setColor(int color){
		int r=(color>>16)&0xFF;
		int g=(color>>8)&0xFF;
		int b=color&0xFF;
		setColor(r,g,b);
	}


	/** drawStringAdrawRectȂǂŎgpF̃Zbg
	 * @param red q
	 * @param green f
	 * @param blue a
	 */
	public void setColor(int red,int green,int blue){
		g.setColor(  new Color(red,green,blue) );
	}


	/** ̕`
	 * @param sx Jn_XW
	 * @param sy JnXYW
	 * @param ex I_XW
	 * @param ey I_YW
	 */
	public void drawLine(int sx,int sy,int ex,int ey){
		g.drawLine(sx,sy,ex,ey);
	}


	/** ̒`̕`
	 * @param x `̍̂wW
	 * @param y `̍̂xW
	 * @param w `̕
	 * @param h `̍
	 */
	public void drawRect(int x,int y,int w,int h){
		g.drawRect(x,y,w,h);
	}


	/** hԂ̒`̕`
	 * @param x `̍̂wW
	 * @param y `̍̂xW
	 * @param w `̕
	 * @param h `̍
	 */
	public void fillRect(int x,int y, int w,int h){
		g.fillRect(x,y,w,h);
	}


	/** ~̕`
	 * @param x ~̒ŜwW
	 * @param y ~̒ŜxW
	 * @param r ~̔a
	 */
	public void drawCircle(int x,int y,int r){
		g.drawArc(x-r,y-r, r*2, r*2 , 0, 360 );
	}


	/** hԂ~̕`
	 * @param x ~̒ŜwW
	 * @param y ~̒ŜxW
	 * @param r ~̔a
	 */
	public void fillCircle(int x,int y,int r){
		g.fillArc(x-r,y-r, r*2, r*2 , 0, 360);
	}


	/** 摜`
	 * @param id 摜IDBimg0.gifȂID0Bimg1.gifȂID1B
	 * @param x 摜̍̂wW
	 * @param y 摜̍̂xW
	 */
	public void drawImage(int id,int x,int y){
		try{
			g.drawImage(images.getImage(id), x, y ,null);
		}catch(Exception e){
			e.printStackTrace();
		}
	}


	/** 摜`
	 * @param id 摜IDBimg0.gifȂID0Bimg1.gifȂID1B
	 * @param x 摜̍̂wW
	 * @param y 摜̍̂xW
	 * @param u 摜gp镔̍wW
	 * @param v 摜gp镔̍xW
	 * @param w `悷镝
	 * @param h `悷鍂
	 */
	public void drawClipImage(int id,int x,int y,int u,int v,int w,int h){
		try{
			g.drawImage(images.getImage(id), x, y,x+w,y+h,u,v,w+u,v+h,null);
		}catch (Exception e) {
			e.printStackTrace();
		}
	}


	/// AtBgXp
	private AffineTransform tr = new AffineTransform();

	/** 摜gkE]ĕ\
	 * @param id@  摜̃io[ł
	 * @param x     摜̒SwWł
	 * @param y     摜̒SxWł
	 * @param xsize ɂǂ̂炢g傷邩H100%ɂĂ܂B(xsize100̎A{B200Ȃ2{̑傫)
	 * @param ysize cɂǂ̂炢g傷邩H100%ɂĂ܂B(ysize100̎A{B200Ȃ2{̑傫)
	 * @param angle 摜x]邩H(pxŎw)notʓx@
	 */
	public void drawScaledRotateImage(int id,int x,int y,
			int xsize,int ysize,double rotate){
		double w = (double)(this.getImageWidth(id))/2.0;
		double h = (double)(this.getImageHeight(id))/2.0;
		this.drawScaledRotateImage(id,x,y,xsize,ysize,rotate,w,h);
	}

	/** 摜gkE]ĕ\
	 * @param id@  摜̃io[ł
	 * @param x     摜̒SwWł
	 * @param y     摜̒SxWł
	 * @param xsize ɂǂ̂炢g傷邩H100%ɂĂ܂B(xsize100̎A{B200Ȃ2{̑傫)
	 * @param ysize cɂǂ̂炢g傷邩H100%ɂĂ܂B(ysize100̎A{B200Ȃ2{̑傫)
	 * @param angle 摜x]邩H(pxŎw)notʓx@
	 * @param px    摜̉]̒SʒûwW
	 * @param py    摜̉]̒SʒûxW
	 */
	public void drawScaledRotateImage(int id,int x,int y,
			int xsize,int ysize,double rotate,double px,double py){
		Image img = this.images.getImage(id);
		if(img == null)
			return;
		Graphics2D gr = (Graphics2D)this.g;
		
		px *= xsize/100.0;
		py *= ysize / 100.0;
		
		//K
		tr.setToIdentity();
		
		tr.translate(x,y);
		tr.rotate(rotate*Math.PI/360.0 );
		tr.translate(-px,-py);

		tr.scale( xsize/100.0,ysize/100.0);
		gr.drawImage(img,tr,null);
	}

	/** 摜̕𓾂
	 * @param id 摜IDBimg0.gifȂID0Bimg1.gifȂID1B
	 * @return idŎw肳ꂽ摜̕Ԃ
	 */
	public int getImageWidth(int id){
		return images.getPicXsize(id);
	}


	/**
	 * 摜̍𓾂
	 * @param id 摜IDBimg0.gifȂID0Bimg1.gifȂID1B
	 * @return idŎw肳ꂽ摜̍Ԃ
	 */
	public int getImageHeight(int id){
		return images.getPicYsize(id);
	}


	/** ̎Zbg
	 * @param seed Zbg闐̃V[h
	 */
	public void setSeed(int seed) {
		rand.setSeed(seed);
	}


	/** min`max܂ł̊Ԃ̃_ȒlԂB
	 * @param min _̍ŏl
	 * @param max _̍ől
	 * @return    _l
	 */
	public int rand(int min,int max){
		int tmp = rand.nextInt();
		if(tmp < 0)
			tmp = -tmp;
		if(min < max){
			max = max - min + 1;
			return tmp%max + min;
		}else{
			min = min - max + 1;
			return tmp%min + max;
		}
	}


	/** Q[Xe[g̕ύX
	 * @param g sgameInterfacepNX
	 * @param flag initAfinalGames̃tOBtrueȂ猻݂̃IuWFNgfinalGameāAinits܂
	 */
	public void changeGameState(gameInterface g , boolean flag){
		if(this.game!=null && flag)
			this.game.finalGame();
		if( g != null && flag)
			g.initGame();
		this.game = g;
	}

	/** Q[Xe[g̕ύX
	 * @param g sgameInterfacepNX
	 */
	public void changeGameState(gameInterface g){
		this.changeGameState( g , true );
	}

	/** Q[Xe[g̕ύX(IɃNX[h)
	 * @param file NXt@Cw肵܂
	 * @param flag initAfinalGames̃tOBtrueȂ猻݂̃IuWFNgfinalGameāAinits܂
	 * @return classt@C̓ǂݍ݂ɐԂ܂
	 */
	public boolean loadGameState( String file ,boolean flag){
		try{
			//Class cur_class = Class.forName(file, true, ClassLoader.getSystemClassLoader());
			Class cur_class = new FileClassLoader().loadClassFile(new File(file) );
			if(cur_class == null)
				return false;
			this.changeGameState( (gameInterface)cur_class.newInstance() , flag);
		}catch(Exception e){
			e.printStackTrace();
			return false;
		}

		return true;
	}

	/** Q[Xe[gftHgԂɂ܂
	 */
	public void resetGame(){
		this.changeGameState( null );
		this.stopBgm();
		this.stopSe();
		this.translate(0,0);
	}


	/** ftHgŎsNX̐ݒ
	 */
	public void setDefaultGameState(gameInterface g){
		this.default_game = g;
	}


	/** XVɍs
	 */
	public void updateMessage(){
		if(this.game!=null){
			this.game.updateGame();
			//Z[u
			if(save_flag){
				this.writeRecord();
				save_flag = false;
			}
		}
		else{
			try{
				this.changeGameState( (gameInterface)default_game.getClass().newInstance() );
			}
            catch(Exception e)
            {
                e.printStackTrace();
			}
		}
		//BGMXg[~OĐȂ̂ŃAbvf[g
		this.bgm.update();
	}


	/** `掞ɍs
	 */
	public void drawMessage(){
		if(this.game!=null && this.g!=null)
			this.game.drawGame();
	}


	/** ʂ𔒂œhԂ
	 * 
	 */
	public void clearScreen(){
		setColor(255,255,255);
		fillRect(0,0,WIDTH,HEIGHT);
	}


	//݂ǂꂭ炢ʂĂ邩H
	private int offset_x,offset_y;

	/** Q[ʂ炷
	 * @param x 炷w 
	 * @param y 炷x
	 */
	public void translate(int x,int y){
		this.g.translate(x-offset_x,y-offset_y);
		this.offset_x = x;
		this.offset_y = y;
	}


	/** AvI
	 */
	public void exitApp(){
		try{
			this.game.finalGame();
		}catch(Exception e){
			e.printStackTrace();
		}
		System.exit(0);
	}


	/** YesNoI_CAOo
	 * @param message mFp̃bZ[W
	 * @return ǏʂԂ
	 */
	public boolean showYesNoDialog(String message){
		return ( JOptionPane.YES_OPTION == 
			JOptionPane.showConfirmDialog(null,message,null,JOptionPane.YES_NO_OPTION ) );
	}


	/** [U[ɕ̓͂߂_CAOo
	 * 
	 * @param message [U[ɑ΂郁bZ[W
	 * @param default_input ftHgԂł̓
	 * @return ͂ꂽbZ[WԂ
	 */
	public String showInputDialog(String message,String default_input){
		return JOptionPane.showInputDialog(null, message,default_input);
	}


	//---------------- Sound ֌W -------------------//
	/// ݖ炵ĂBGM
	private int cur_bgm = -1;

	/** BGMĐ
	 * BGM̍Đ͔rIŁAƂ̂͊{Ȃł
	 * @param id BGM̔ԍ
	 */
	public void playBgm(int id){
		this.playBgm(id,true);
	}


	/** BGMĐ
	 * BGM̍Đ͔rIŁAƂ̂͊{Ȃł
	 * @param id BGM̔ԍ
	 * @param loop [v邩ǂw肷
	 */
	public void playBgm(int id,boolean loop){
		if(cur_bgm != id){
			bgm.stopSound();
			bgm.playSound(id,loop);
		}
		cur_bgm = id;
	}


	/** BGM{[
	 * @param volume ʂ̎w(0-100)
	 */
	public void changeBgmVolume(int volume){
		bgm.changeVolume(volume);
	}


	/** BGM~
	 */
	public void stopBgm(){
		if(bgm != null)
			bgm.stopSound();
		cur_bgm = -1;
	}


	/** BGMꎞ~
	 */
	public void pauseBgm(){
		bgm.pauseSound();
		cur_bgm = -1;
	}


	/** SEĐ
	 * @param id SE̔ԍ
	 */
	public void playSe(int id){
		this.playSe(id,false);
	}


	/** SEĐ
	 * @param id SE̔ԍ
	 * @param loop SE[v邩Zbg
	 */
	public void playSe(int id,boolean loop){
		this.sound_effect.playSound(id,loop);
	}


	/** SE{[
	 * @param volume ʂ̎w(0-100)
	 */
	public void changeSeVolume(int volume){
		this.sound_effect.changeVolume(volume);
	}


	/** SĂSE~
	 */
	public void stopSe(){
		this.sound_effect.stopSound();
	}


	/** SĂSEꎞ~
	 */
	public void pauseSe(){
		this.sound_effect.pauseSound();
	}

	//-------------------L[͊֌W-----------//

	/** L[Ă钷𒲂ׂ
	 * Ŏw肵L[Aǂ̂炢Ă邩ԂB
	 * @param keyCode KEY_0 Ȃu0L[vKEY_LEFT Ȃ uJ[\L[vƂŁAׂL[w
	 * @return  keyCodeŎw肳ꂽL[Ă钷ԂB-1B0Ȃ牟ĂȂB1ȏ͉Ă钷
	 */
	public int getKeyPressLength(int keyCode){
		return input.getKeyPressLength(keyCode);
	}


	/** L[Ă邩m߂
	 * Ŏw肵L[AĂꍇtrueԂ܂B
	 * @param keyCode KEY_0 Ȃu0L[vKEY_LEFT Ȃ uJ[\L[vƂŁAׂL[w
	 * @return  keyCodeŎw肳ꂽL[ꂽłꍇ trueBĂꍇ false
	 */
	public boolean isKeyPress(int keyCode){
		return input.isKeyPressed(keyCode);
	}


	/** L[uԂm߂
	 * Ŏw肵L[AꂽłꍇtrueԂ܂B
	 * @param keyCode KEY_0 Ȃu0L[vKEY_LEFT Ȃ uJ[\L[vƂŁAׂL[w
	 * @return  keyCodeŎw肳ꂽL[ꂽłꍇ trueBL[ςȂAĂԂ̏ꍇ false
	 */
	public boolean isKeyPushed(int keyCode){
		return input.isKeyPushed(keyCode);
	}


	/** L[𗣂uԂm߂
	 * Ŏw肵L[AłꍇtrueԂ܂B
	 * @param keyCode KEY_0 Ȃu0L[vKEY_LEFT Ȃ uJ[\L[vƂŁAׂL[w
	 * @return  keyCodeŎw肳ꂽL[ꂽłꍇ trueBL[ĂAςȂ̏Ԃ̏ꍇ false
	 */
	public boolean isKeyReleased(int keyCode){
		return input.isKeyReleased(keyCode);
	}


	/** }EXXW擾
	 * @return ݂̃}EXXWԂ
	 */
	public int getMouseX(){
		return this.input.getMouseX();
	}


	/** }EXYW擾
	 * @return ݂̃}EXXWԂ
	 */
	public int getMouseY(){
		return this.input.getMouseY();
	}


	/** }EX̃{^Ă鎞Ԃ𒲂ׂ
	 * @return }EX̉Ă鎞Ԃ𒲂ׂ
	 */
	public int getMouseClickLength(){
		return this.input.getMouseClickLength();
	}


	/** }EX̃{^uԂׂ
	 * @return }EX̃{^uԂȂtrueԂ
	 */
	public boolean isMousePushed(){
		return this.input.isMousePushed();
	}


	/** }EX̃{^𗣂uԂ𒲂ׂ
	 * @return }EX̃{^𗣂uԂȂtrueԂ
	 */
	public boolean isMouseReleased(){
		return this.input.isMouseReleased();
	}


	/** }EX̃{^Ă邩ׂ
	 * @return }EX̃{^ĂtrueԂ
	 */
	public boolean isMousePress(){
		return this.input.isMousePress();
	}


	//-------------------- Z[uf[^n ------------------//
	///Z[uf[^pobt@
	private int saveData[];
	//Z[uf[^ɕύX̃tO
	private boolean save_flag = false;

	/** Z[uf[^obt@ɗߍ񂾃f[^o
	 */
	private void writeRecord(){
		byte tmp[] = saveDataUtil.intarr2bytearr(saveData);
		saveDataUtil.writeByteArray("savedata.dat", tmp);
	}


	/** t@CZ[uf[^obt@ɗߍ
	 */
	private void readRecord(){
		byte tmp[] = saveDataUtil.readByteArray("savedata.dat");
		if(tmp==null){
			this.saveData = new int[SAVE_DATA_SIZE];
			this.writeRecord();
		}else{
			this.saveData = saveDataUtil.bytearr2intarr(tmp);
		}
	}


	/** Z[uf[^obt@f[^擾B
	 * @param position Z[uf[^obt@̈ʒuw
	 * @return w肳ꂽʒuf[^ǂݏoĕԂ
	 */
	public int load(int position){
		return saveData[position];
	}


	/** Z[uf[^obt@Ƀf[^Zbg
	 * @param position Z[uf[^obt@̈ʒuw
	 * @param param Z[uf[^ɏޒlZbg
	 */
	public void save(int position,int param){
		this.saveData[position] = param;
		save_flag = true;
	}


	//--------------- 蔻n ----------------//

	/** ``Ƌ`aԂĂ邩肷
	 * @param x1 ``̍wW
	 * @param y1 ``̍xW
	 * @param w1 ``̕
	 * @param h1 ``̍
	 * @param x2 `a̍wW
	 * @param y2 `a̍xW
	 * @param w2 `a̕
	 * @param h2 `a̍
	 *
	 */
	public boolean checkHitRect(
			int x1,int y1,int w1,int h1,
			int x2,int y2,int w2,int h2
	){
		return collision.checkHitRect(x1, y1, w1, h1, x2, y2, w2, h2);
	}


	/** 摜AƉ摜BwʒuɏƂƂɉ摜mĂ邩m߂
	 * 
	 * drawImagełA摜AƉ摜BƂ
	 * @param img1 摜AIDw
	 * @param x1 摜A̍XWw
	 * @param y1 摜A̍YWw
	 * @param img2 摜BIDw
	 * @param x2 摜B̍XWw
	 * @param y2 摜B̍YWw
	 * @return 摜mĂ邩ǂԂ܂
	 */
	public boolean checkHitImage(
			int img1,int x1,int y1,int img2,int x2,int y2
	){
		return this.checkHitRect(
				x1,y1,this.getImageWidth(img1),this.getImageHeight(img1),
				x2,y2,this.getImageWidth(img2),this.getImageHeight(img2) );
	}


	/** ~AƉ~B̓蔻s
	 * 
	 * @param x1 ~A̒SXW
	 * @param y1 ~A̒SYW
	 * @param r1 ~A̔a
	 * @param x2 ~B̒SXW
	 * @param y2 ~B̒SYW
	 * @param r2 ~B̔a
	 * @return ~AƉ~BǂH
	 */
	public boolean checkHitCircle(int x1,int y1,int r1,
		int x2,int y2,int r2){
		return collision.checkHitCircle(x1, y1, r1, x2, y2, r2);
	}

	//-----------------@wñ\bh ------------//

	/** ()߂
	 * 
	 * @param data ߂
	 * @return ŗ^ꂽ̕Ԃ
	 */
	public double sqrt(double data){
		return Math.sqrt(data);
	}


	/** cos߂
	 * 
	 * @param angle pxw肷(not ʓx@)
	 * @return anglecos
	 */
	public double cos(double angle){
		return Math.cos(angle * Math.PI / 180.0);
	}


	/** sin߂
	 * 
	 * @param angle pxw肷(not ʓx@)
	 * @return anglesin
	 */
	public double sin(double angle){
		return Math.sin(angle * Math.PI / 180.0);
	}


	/** atan2߂(xNg̊px߂)
	 * 
	 * @param x xNgX
	 * @param y xNgY
	 * @return xNg̊pxԂ
	 */
	public double atan2(double x,double y){
		return Math.atan2(x,y) * 180.0 / Math.PI;
	}


	//------------- 摜ETEh̊Ǘ҂set/get --------//

	/** 摜̊Ǘ҂Zbg܂B
	 * @param manager ύX摜̊Ǘ
	 */
	public void setImageManager(imageManager manager){
		this.images = manager;		
	}


	/** ʉ̊Ǘ҂Zbg܂
	 * @param manager ύXʉ̊Ǘ
	 */
	public void setSeManager(soundManagerInterface manager){
		if( this.sound_effect != null)
			this.sound_effect.stopSound();
		this.sound_effect = manager;		
	}


	/** BGM̊Ǘ҂Zbg܂
	 * @param manager ύXBGM̊Ǘ
	 */
	public void setBgmManager(soundManagerInterface manager){
		this.stopBgm();
		this.bgm = manager;		
	}


	/** gameCanvasōA摜ǗĂz擾܂
	 * @return ݂gameCanvas̉摜Ǘ
	 */
	public imageManager getImageManager(){
		return this.images;
	}


	/** gameCanvasōAʉǗĂz擾܂ 
	 * @return ݂gameCanvašʉǗ
	 */
	public soundManagerInterface getSeManager(){
		return this.sound_effect;
	}


	/** gameCanvasōABGM̊ǗĂz擾܂ 
	 * @return ݂gameCanvasBGMǗ
	 */
	public soundManagerInterface getBgmManager(){
		return this.bgm;
	}


}
