package gameCanvasUtil;

import gameCanvasUtil.vector.*;

/** Փ˔Ȃǂ܂Ƃ߂NXł
 */
public class collision {
	
	/** ``Ƌ`aԂĂ邩肷
	 * @param x1 ``̍wW
	 * @param y1 ``̍xW
	 * @param w1 ``̕
	 * @param h1 ``̍
	 * @param x2 `a̍wW
	 * @param y2 `a̍xW
	 * @param w2 `a̕
	 * @param h2 `a̍
	 *
	 */
	static public boolean checkHitRect(
			int x1,int y1,int w1,int h1,
			int x2,int y2,int w2,int h2
	){
		if( x1 < x2+w2 && x1+w1 > x2 &&
				y1 < y2+h2 && y1+h1 > y2 ){
			return true;
		}
		return false;
	}
	

	
	
	/** ~AƉ~B̓蔻s
	 * 
	 * @param x1 ~A̒SXW
	 * @param y1 ~A̒SYW
	 * @param r1 ~A̔a
	 * @param x2 ~B̒SXW
	 * @param y2 ~B̒SYW
	 * @param r2 ~B̔a
	 * @return ~AƉ~BǂH
	 */
	static public boolean checkHitCircle(double x1,double y1,double r1,
		double x2,double y2,double r2){
		double r = r1+r2;
		double x = x1-x2;
		double y = y1-y2;
		
		if( x*x + y*y <= r*r ){
			return true;
		}
		return false;
	}
	

	/** _Ԃ̋߂
	 * 
	 * @param x1 _AXW
 	 * @param y1 _AYW
	 * @param x2 _BXW
	 * @param y2 _BYW
	 * @return _AƓ_B̋Ԃ
	 */
	static public double getPointDistance(double x1,double y1,
			double x2,double y2){
		double x = x1-x2;
		double y = y1-y2;
		
		return Math.sqrt(x*x+y*y);
	}
	
	/** AƐB̓蔻
	 * 
	 * @param st_x1 A̎n_XW
	 * @param st_y1 A̎n_YW
	 * @param ed_x1 ȀI_XW
	 * @param ed_y1 ȀI_YW
	 * @param st_x2 B̎n_XW
	 * @param st_y2 B̎n_YW
	 * @param ed_x2 B̏I_XW
	 * @param ed_y2 B̏I_YW
	 * @return m̌_ԂB(_ꍇAnullԂ)
	 */
	static public gcVector2D checkHitVector(double st_x1,double st_y1,double ed_x1,double ed_y1,
			double st_x2,double st_y2,double ed_x2,double ed_y2){

		gcVector2D p = null;
		double s,r;

		double acx = st_x2 - st_x1;
		double acy = st_y2 - st_y1;
		double bunbo = (ed_x1 - st_x1)*(ed_y2 - st_y2) 
		- (ed_y1 - st_y1)*(ed_x2 - st_x2 );
		
		if(bunbo==0.0)
			return null;


		r = ( (ed_y2 - st_y2)*acx - (ed_x2 - st_x2)*acy ) / bunbo;
		s = ( (ed_y1 - st_y1)*acx - (ed_x1 - st_x1)*acy ) / bunbo;
		
		if( 0.0 <= r && r<= 1.0 && 0.0 <= s && s <= 1.0){
			p = new gcVector2D(
					(int)(st_x1 + (ed_x1-st_x1)*r) ,
					(int)(st_y1+ (ed_y1-st_y1)*r) );
		}
		return p;
	}
	
	
	/** AƐB̓蔻s(new Ȃ)
	 * 
	 * @param st_x1 A̎n_XW
	 * @param st_y1 A̎n_YW
	 * @param ed_x1 ȀI_XW
	 * @param ed_y1 ȀI_YW
	 * @param st_x2 B̎n_XW
	 * @param st_y2 B̎n_YW
	 * @param ed_x2 B̏I_XW
	 * @param ed_y2 B̏I_YW
	 * @param p     |Cgi[
	 * @return m̌_ꍇAtrue,
	 */
	static public boolean checkHitVector(double st_x1,double st_y1,double ed_x1,double ed_y1,
			double st_x2,double st_y2,double ed_x2,double ed_y2,gcVector2D p){

		double s,r;

		double acx = st_x2 - st_x1;
		double acy = st_y2 - st_y1;
		double bunbo = (ed_x1 - st_x1)*(ed_y2 - st_y2) 
		- (ed_y1 - st_y1)*(ed_x2 - st_x2 );
		
		
		if(bunbo==0.0)
			return false;


		r = ( (ed_y2 - st_y2)*acx - (ed_x2 - st_x2)*acy ) / bunbo;
		s = ( (ed_y1 - st_y1)*acx - (ed_x1 - st_x1)*acy ) / bunbo;
		
		if( 0.0 <= r && r<= 1.0 && 0.0 <= s && s <= 1.0){
			p.setX (st_x1 + (ed_x1-st_x1)*r);
			p.setY(st_y1+ (ed_y1-st_y1)*r);
		}
		return true;
	}
	
	/** Ɠ_̋𓾂
	 * 
	 * @param px _XW
	 * @param py _YW
	 * @param st_x ̎n_XW
	 * @param st_y	̎n_YW
	 * @param ed_x ̏I_XW
	 * @param ed_y	̏I_YW
	 * @return _Ɛ̋
	 */
	static public double getVectorPointDistance(double px,double py,double st_x,double st_y,double ed_x,double ed_y){	
		double distance = 0.0;
		
		double dx,dy;
		double a,b,t;
		double tx,ty;
		dx = ed_x - st_x;
		dy = ed_y - st_y;
		
		a = (dx*dx + dy*dy);
		b = dx*(st_x-px) + dy*(st_y-py);
		t = - b / a;
		
		if(t<0.0)
			t = 0.0;
		if(t>1.0)
			t = 1.0;

		tx = st_x + dx*t;
		ty = st_y + dy*t;
		
		distance = Math.sqrt((px-tx)*(px-tx) + (py-ty)*(py-ty));
		return distance;
	}
	

}
