package gameCanvasUtil;
import java.io.*;
import java.util.ArrayList;
import java.util.jar.JarFile;


/** t@C݁EǂݍݓyɂNXB
 *  
 *  zt@CɏoAbyte -> int ̕ϊs肷NX
 */
public class saveDataUtil {

	/** datat@Cɏ݂܂
	 * 
	 * @param file t@C̎w
	 * @param data f[^̎w
	 * @return t@C݂ɐǂ
	 */
	static public boolean writeByteArray( String file,byte data[] ){
		FileOutputStream out = null;
		try{
			out = new FileOutputStream(file);
			out.write(data);
			out.close();
		}catch(Exception e){
			try{
				out.close();
			}catch(Exception e2){
                return false;
			}
		}
		return true;
	}

	/** oCg̃f[^ǂݍŃoCgzɂĕԂ܂
	 * 
	 * @param file t@C̎w
	 * @return ǂݍ񂾃f[^ԂB(new)
	 */
	static public byte[] readByteArray(String file){
		byte[] data = null;;
		File fp = new File(file);
		long size = fp.length();
		data = new byte[(int)size];
		FileInputStream in = null;
		try{
			in = new FileInputStream(file);
			in.read(data);
			in.close();
		}catch(Exception e){
			try{
				in.close();
			}catch(Exception e2){
                return null;
			}
		}
		return data;
	}

	/** t@C̒gdataɊi[Ă
	 * 
	 * @param file t@C̎w
	 * @param data f[^̊i[
	 * @return t@CǂݍݐǂH
	 */
	static public boolean readByteArray(String file,byte data[]){
		FileInputStream in = null;
		try{
			in = new FileInputStream(file);
			in.read(data);
			in.close();
		}catch(Exception e){
			try{
				in.close();
			}
            catch(Exception e2){
                return false;
			}
		}
		return true;
	}


	/**  intoCgzɓ˂
	 * 
	 * @param dest z˂ސ
	 * @param offset z˂ރItZbg
	 * @param src ˂ޒl
	 */
	public static void int2byte(byte dest[],int offset,int src){
		dest[offset+0] = (byte)((src>>0)&0xff);
		dest[offset+1] = (byte)((src>>8)&0xff);
		dest[offset+2] = (byte)((src>>16)&0xff);
		dest[offset+3] = (byte)((src>>24)&0xff);
	}

	/** oCgz񂩂intԂ
	 * 
	 * @param src oƂ̔z
	 * @param offset oItZbg
	 * @return ԂINT
	 */
	public static int byte2int(byte src[],int offset){
		return ((src[offset+0]&0xff)<<0)+
		((src[offset+1]&0xff)<<8)+
		((src[offset+2]&0xff)<<16)+
		((src[offset+3]&0xff)<<24);
	}

	/** int̔z񂩂byte̔z֕ϊ܂
	 * @param src bytezɕϊint̔z
	 * @return srcϊbytez
	 */
	public static byte[] intarr2bytearr(int src[]){
		byte val[] = new byte[src.length * 4];
		for(int i=0;i<src.length;i++){
			int2byte(val,i*4,src[i]);
		}
		return val;
	}

	/** byte̔z񂩂int̔z֕ϊ܂
	 * @param src intzɕϊbyte̔z
	 * @return byteϊintz
	 */
	public static int[] bytearr2intarr(byte src[]){
		int val[] = new int[src.length / 4];
		for(int i=0;i<val.length;i++){
			val[i] = byte2int(src,i*4);
		}
		return val;
	}

	/** t@C當ǂݍŁAsƂɕ܂ 
	 * @param file eLXgt@C̖Ow
	 * @return sƂɕꂽ
	 */
	public static String[] readStringList(String file){
		try{
			//s𒲂ׂ
			String str[];
			FileInputStream 	fi = new FileInputStream(file);
			InputStreamReader 	ir	= new InputStreamReader(fi);
			BufferedReader 		br	= new BufferedReader(ir);
			int line_num;
			ArrayList arr = new ArrayList();

			for(line_num=0;;line_num++){
				String line;
				if( (line = br.readLine()) == null){
					break;
				}
				arr.add(line);
			}
			fi.close();
			ir.close();
			br.close();

			//ۂɓǂݍ
			str = new String[line_num];
			for(int i=0;i<line_num;i++){
				str[i] = (String)arr.get(i);
			}
			return str;
		}catch(Exception e){
			return null;
		}
	}

	/** t@CString̔zsł܂
	 * @param file ރt@C̎w
	 * @param data ޕz̎w
	 * @return ݂ɐǂԂ܂
	 */
	public static boolean writeStringList(String file,String[]data){
		try{
			String str="";
			for(int i=0;i<data.length;i++){
				str += data[i];
				if(i!=data.length-1)
					str += "\n";
			}
			FileOutputStream fo = new FileOutputStream(file);
			fo.write(str.getBytes());
			fo.close();
		}catch(Exception e){
			return false;
		}		
		return true;
	}

	/** Resourcep̃oCit@Cǂݍ݂܂
	 * 
	 * @param binaryName jart@C̖Ow
	 * @return ǂݍ񂾃t@C̒̃oCi
	 */
	public static byte[] readResourceBinary(String binaryName){
		byte val[] = null;
		try{
			ArrayList arr = new ArrayList();
			byte tmp[],wbuf[];
			InputStream is = (new Object()).getClass().getResourceAsStream("/"+binaryName);

			//ۂ̓ǂݍ
			int fsize = 0;
			tmp = new byte[1024];
			while(true){
				int tmpfsize = is.read(tmp,0,tmp.length);
				if(tmpfsize<0){
					break;
				}
				wbuf = new byte[tmpfsize];
				System.arraycopy( tmp , 0, wbuf, 0, tmpfsize );
				fsize += tmpfsize;
				arr.add(wbuf);
			}
			is.close();

			//ǂݍ񂾒lvalɊi[
			val = new byte[fsize];
			
			fsize = 0;
			for(int i=0;i<arr.size();i++){
				tmp = (byte[])arr.get(i);
				for(int j=0;j <tmp.length && fsize+j < val.length;j++){
					val[j+fsize] = tmp[j];
				}
				fsize += tmp.length;
			}

		}catch(Exception e){
			return null;
		}
		return val;
	}


	/** Resourcep̕t@Cǂݍ݂܂
	 * 
	 * @param binaryName jart@C̖Ow
	 * @return ǂݍ񂾃t@C̒̕
	 */
	public static String[] readResourceStrings(String strName){		
		String str[] = null;
		try{
			//oCiƂēǂݍŁA
			byte tmp[] = readResourceBinary(strName);
			if(tmp==null){
				return null;
			}
			String tmpstr = new String(tmp);
			

			//s𐔂
			int strcnt=1;
			for(int i=0;i<tmpstr.length();i++){
				if(tmpstr.charAt(i)=='\n'){
					strcnt++;
				}
			}
			//e[ȕ
			str = new String[strcnt];
			for(int i=0;i<str.length;i++){
				str[i]="";
			}
			//e[uɓ˂
			strcnt = 0;
			for(int i=0;i<tmpstr.length();i++){
				if(tmpstr.charAt(i)=='\n'){
					strcnt++;
				}else if(tmpstr.charAt(i)!='\r'){
					str[strcnt] += tmpstr.charAt(i);				
				}
			}

		}catch(Exception e){
			return null;
		}		
		return str;
	}

	/** gqƃfBNgw肵āAȉɂt@CԂ܂B
	 * @param dir TofBNg
	 * @param ext gqB"*"ƑSt@CԂ܂B"."ƁASfBNgԂ܂B
	 */
	public static String []lsCommand(String dir,String ext){
		File f = new File(dir);
		
		String list[] = f.list();
		String ret []= null;
		boolean flag[] = new boolean[list.length];
		int cnt = 0;
		//
		for(int i=0;i<list.length;i++){
			list[i] = dir + "/"+list[i];
			if( ext.equals(".") ){
				if( new File(list[i]).isDirectory() ){
					flag[i] = true;
					cnt++;
				}
			}else{
				if( ( ext.equals("*") || list[i].endsWith(ext) )
					&& new File(list[i]).isFile() ){
					flag[i] = true;
					cnt++;
				}
			}
		}
		//
		ret = new String[cnt];
		cnt = 0;
		for(int i=0;i<list.length;i++){
			if(flag[i]){
				ret[cnt] = list[i];
				cnt ++;
			}
		}

		return ret;
	}
}
